/*
 * Chess game implementation.
 * By Carlos Varela.  February, 1997
 *
 * MoveReader class.  Contains a move reader from a BufferedReader.
 */

package chess;

import java.io.*;

public class MoveReader extends BufferedReader implements java.io.Serializable {

  String currentLine;

  public MoveReader(Reader r){
    super(r);
    currentLine = new String("");
  }

  /**
   * readMove reads the next Move from a BufferedReader
   */
  public String readMove() throws IOException{
    // FIX: Use a StringTokenizer (" \n\t\#") within each line...
    while ((currentLine = currentLine.trim()).length() < 3){
      do {
	currentLine = super.readLine();
	if (currentLine == null) throw new EOFException();
      } while (currentLine.charAt(0) == '#');
    }
    String move = currentLine;
    int next = currentLine.indexOf(' ',4);
    if (next != -1)    // eat move comments ? ! [p] 
      currentLine = currentLine.substring(next);
    else  // no more moves in this line
      try {
	currentLine = currentLine.substring(4);  // Bug: Ignores "0-0"...
      } catch (IndexOutOfBoundsException e){  // Rest of line smaller than 5
	currentLine = "";
      }
    return move;
  }
}
/* In case a new piece was being read from standard input:

	System.out.print("Choose Q, T, B, N:");
	BufferedReader in =
	  new BufferedReader(new InputStreamReader(System.in));
	char r =  in.read();
	while (newPiece == null){
	  r = in.read();

*/
