package submit;
import java.util.*;

public interface Board extends java.io.Serializable {
  public void printAscii(); //Prints the board.
  public void doMove(Move a); //Applies the move to the board.  Changes the results of printAscii.
  public void undoMove(Move m); //Undoes the move to the board.
  /**
   * iterativeDeepening creates a tree of possible moves from a position.
   * receives the color that plays next,
   * receives the maximum depth to look ahead
   * returns a tree with the next possible valid moves.
   * DYNAMIC (changes board)
   */
  public MoveTree iterativeDeepening(boolean color, int depth);
}
