package submit;

import java.util.*;

class Sample {

    public static void main(String[] args){
    //The line below lets you play chess.
    //(new chess.Game()).play(args);
    Board b;

    if (args.length == 2){
        String position = args[1];
        b = constants.generateBoard(position);
    } else {
        // Create a new chess board/game
        b = constants.generateBoard();
    }

    // Print it in ASCII form
    b.printAscii();

    // Generate a tree of moves, sorted from best move
    MoveTree mt=
    b.iterativeDeepening(constants.WHITE,                         // White plays first
                 Integer.parseInt(args[0]));          // Look at this depth of moves

    if (constants.DEBUG) System.out.println(mt);
    System.out.println(mt.getMaxMin());
    int max = -constants.INFINITY;
    for(Object o: mt.getNextMoves()) {
      int newmax=((MoveTree) o).getMaxMin();
      if (newmax>max) max=newmax;
    }
    boolean once=false;
    for (Object o: mt.getNextMoves()) {
      Vector bestMoves = new Vector();
      MoveTree mt2=(MoveTree)o;
      if (mt2.getMaxMin() != max) continue;
      while (mt2!=null){
        // Perform the best move in the board and print it
        Move bestMove = mt2.getMove();
        bestMoves.addElement(bestMove);
        //Only prints the first best result.
        if (!once) {
          b.doMove(bestMove);
          b.printAscii();
        }
        // Follow the best sub-tree down
        mt2 = mt2.getMaxMinTree();
      }
      once=true;
      System.out.println(bestMoves);
    }

   }


}
